format PE GUI 4.0
entry main

include 'win32a.inc'

section '.main' code readable executable

  main:
	push	GameWindowTitle
	push	GameWindowClass
	call	[FindWindowA]
	mov	[GAMEWINDOW],eax
	cmp	eax,$00
	je	DisplayErrorMessage
	; Get the module address (.exe in this case)
	call	GetModuleBaseAddress
	; Allocate memory
	call	HappyAlloc
	; GetCurrentDirectory
	push	lpBuffer
	push	nBufferLength
	call	[GetCurrentDirectoryA]
	; Get path string size
	push	lpBuffer
	call	GetAnsiStringSize
	; Add the dll name to our current executable path
	mov	esi,RDK_DLL
	push	eax
	add	eax,lpBuffer
	mov	edi,eax
	mov	ecx,$09
	rep movsb
	; Move data from array to array
	mov	esi,lpBuffer ; Ansi string source
	mov	edi,DLL_PATH ; Ansi string destination
	pop	eax
	add	eax,$09      ; String size + 1 (zero terminated)
	mov	ecx,eax      ; Characters to copy
	rep movsb	     ; Copy string
	; Preparing bytes for write
	; 01
	mov	eax,[HAPPYMEM]
	add	eax,$100
	mov	dword [LOAD_DLL_ARRAY+$01],eax
	; 02
	mov	eax,[BASEADDRESS]
	add	eax,$26F070
	mov	dword [LOAD_DLL_ARRAY+$07],eax
	; 03
	mov	eax,[HAPPYMEM]
	add	eax,$200
	mov	dword [LOAD_DLL_ARRAY+$0C],eax
	; 04
	mov	eax,[BASEADDRESS]
	add	eax,$26F06C
	mov	dword [LOAD_DLL_ARRAY+$13],eax
	; 05
	mov	eax,[BASEADDRESS]
	add	eax,$26F208
	mov	dword [LOAD_DLL_ARRAY+$1B],eax
	; Writing used strings to allocated memory
	mov	eax,[HAPPYMEM]
	add	eax,$100
	push	eax
	push	256
	push	DLL_PATH
	call	WriteCode32
	; DLL_FUNCTION
	mov	eax,[HAPPYMEM]
	add	eax,$200
	push	eax
	push	256
	push	DLL_FUNCTION
	call	WriteCode32
	; Write bytes to allocated memory
	mov	eax,[HAPPYMEM]
	push	eax
	push	$1F
	push	LOAD_DLL_ARRAY
	call	WriteCode32
	; Creating thread on target process to load dll
	; Get target process handle
	push	PROCID
	push	[GAMEWINDOW]
	call	[GetWindowThreadProcessId]
	push	[PROCID]
	push	FALSE
	push	PROCESS_ALL_ACCESS
	call	[OpenProcess]
	mov	[PROCHANDLE],eax
	; Create remote thread
	push	THREAD_ID
	push	00
	push	00
	push	[HAPPYMEM]
	push	00
	push	00
	push	[PROCHANDLE]
	call	[CreateRemoteThread]
	mov	[THREAD_HANDLE],eax
	; CloseHandle
	push	[PROCHANDLE]
	call	[CloseHandle]
	; End process
	push	0
	call	[ExitProcess]

section '.func' code readable executable

  ; ======================================================= M y     F u n c t i o n s     S t a r t =======================================================

  ; Functions that may be used by the trainer

  ; Parameters: PointerToArrayOfByte, ArraySize, StartAddress
  ; push       StartAddress
  ; push       ArraySize
  ; push       PointerToArrayOfByte
  ; call       WriteCode32
  WriteCode32:
  ;  [ebp+$08] = pointer to array
  ;  [ebp+$0C] = size of array
  ;  [ebp+$10] = start address
     push	ebp
     mov	ebp,esp
     ; Check if game is running
     push	GameWindowTitle
     push	GameWindowClass
     call	[FindWindowA]
     mov	[GAMEWINDOW],eax
     cmp	[GAMEWINDOW],$00
     je 	.game_not_running
  .open_process:
     push	PROCID
     push	[GAMEWINDOW]
     call	[GetWindowThreadProcessId]
     push	[PROCID]
     push	FALSE
     push	PROCESS_ALL_ACCESS
     call	[OpenProcess]
     mov	[PROCHANDLE],eax
  .make_memory_writeable:
     mov	esi,[ebp+$10]
     lea	eax,[ebp+$10]
     mov	[ebp+$10],eax
     push dword [ebp+$10]
     push	PAGE_EXECUTE_READWRITE
     push	$1000
     push	esi
     push	[PROCHANDLE]
     call	[VirtualProtectEx]
  .write_to_memory:
     mov	[ebp+$10],esi
     lea	eax,[ebp+$08]
     push	[MYWRITE]
     push dword [ebp+$0C] ;byte count
     push dword [ebp+$08] ;pointer to array
     push dword [ebp+$10] ;address
     push	[PROCHANDLE]
     call	[NtWriteVirtualMemory]
  .close_proc_handle:
     push	[PROCHANDLE]
     call	[CloseHandle]
     mov	eax,$FFFFFFFF
     jmp	.return
  .game_not_running:
     mov	eax,$12312300
  .return:
     leave
     ret	$000C

  ; Parameters: Address to check, byte to check
  ; push byte
  ; push address
  ; call CheckByte
  CheckByte:
     push	ebp
     mov	ebp,esp
     ; Check if game is running
     push	GameWindowTitle
     push	GameWindowClass
     call	[FindWindowA]
     mov	[GAMEWINDOW],eax
     cmp	[GAMEWINDOW],$00
     je 	.game_not_running
  .open_process:
     push	PROCID
     push	[GAMEWINDOW]
     call	[GetWindowThreadProcessId]
     push	[PROCID]
     push	FALSE
     push	PROCESS_ALL_ACCESS
     call	[OpenProcess]
     mov	[PROCHANDLE],eax
  .read_memory:
     push	[MYREAD]
     push	$01
     push	CHECK
     push dword [ebp+$08]
     push	[PROCHANDLE]
     call	[NtReadVirtualMemory]
     push	[PROCHANDLE]
     call	[CloseHandle]
     mov	eax,[ebp+$0C]
     cmp	[CHECK],al
     je 	.equal
  .not_equal:
     mov	eax,$33
     jmp	.return
  .equal:
     mov	eax,$FF
     jmp	.return
  .game_not_running:
     mov	eax,$12312300
     jmp	.return
  .return:
     leave
     ret	$0008

  CallHappyAlloc:
     call	HappyAlloc
     ret

  HappyAlloc:
     push	GameWindowTitle
     push	GameWindowClass
     call	[FindWindowA]
     mov	[HAPPYWINDOW],eax
     cmp	[HAPPYWINDOW],00
     jne	.happyallocexec
     jmp	.happyallocdone
  .happyallocexec:
     mov	[HappyMemSucceed],00
     mov	[HAPPYMEM],00
  .open_process:
     push	PROCID
     push	[HAPPYWINDOW]
     call	[GetWindowThreadProcessId]
     push	[PROCID]
     push	FALSE
     push	PROCESS_ALL_ACCESS
     call	[OpenProcess]
     mov	[PROCHANDLE],eax
  .resume:
     push	PAGE_EXECUTE_READWRITE
     push	MEM_COMMIT
     push	$1000
     push	0
     push	[PROCHANDLE]
     call	[VirtualAllocEx]
     mov	[HAPPYMEM],eax
     cmp	[HAPPYMEM],$00000000
     jne	.validatehappymem
     jmp	.happyallocexec
  .validatehappymem:
     mov	[HappyMemSucceed],01
  .happyallocdone:
     push	[PROCHANDLE]
     call	[CloseHandle]
     ret

  SourceDest:
  ; Mom, I love you! :D
     push	ebp
     mov	ebp,esp
     mov	eax,[ebp+$08] ; Source address
     mov	ebx,[ebp+$0C] ; Destination address
     mov	edx,[ebp+$10] ; Offset
     sub	ebx,eax
     sub	ebx,$05
     sub	ebx,edx
     mov	eax,ebx       ; Result gets stored in eax register
     leave
     ret	$000C

  GetModuleBaseAddress:
     push    GameWindowTitle
     push    GameWindowClass
     call    [FindWindowA]
     mov     [GAMEWINDOW],eax
     ; GetWindowThreadProcessId
     push    PROCID
     push    [GAMEWINDOW]
     call    [GetWindowThreadProcessId]
     ; Open process
     push    [PROCID]
     push    FALSE
     push    PROCESS_ALL_ACCESS
     call    [OpenProcess]
     mov     [PROCHANDLE],eax
     push    [PROCID]
     push    $00000008
     call    [CreateToolhelp32Snapshot]
     mov     [PROCSNAPSHOT],eax
     mov     [HAPPYMODULE.dwSize],$00050000
  .try_Module32First:
     push    HAPPYMODULE
     push    [PROCSNAPSHOT]
     call    [Module32First]
     cmp     eax,00
     je      .error

     jmp     .module_found ; We want the .exe module, so the first is what we need

     jne     .try_Module32Next
  .try_Module32Next:
     push    HAPPYMODULE
     push    [PROCSNAPSHOT]
     call    [Module32Next]
     push    HAPPYDLL
     push    HAPPYMODULE.szModule
     call    [lstrcmpiA]
     cmp     eax,00
     je      .module_found
     jne     .try_Module32Next
  .module_found:
     mov     eax,[HAPPYMODULE.modBaseAddr]
     mov     [BASEADDRESS],eax
     push    [PROCSNAPSHOT]
     call    [CloseHandle]
     ret
  .error:
     mov     eax,$757
     ret

  GetAnsiStringSize:
     push	ebp
     mov	ebp,esp
     mov	ebx,[ebp+$08]
     xor	eax,eax
  .check:
     cmp byte	[ebx+eax],$00
     je 	.check_end
     add	eax,$01
     jmp	.check
  .check_end:
     leave
     ret	$0004

  DisplayErrorMessage:
     cmp     [isMessageDisplaying],01
     jne     .go
     jmp     .bye
     .go:
     mov     [isMessageDisplaying],01
     push    MB_OK or MB_ICONHAND
     push    ERROR_TITLE
     push    ERROR_RUNGAME_FIRST
     push    0
     call    [MessageBoxA]
     mov     [isMessageDisplaying],00
  .bye:
     push    0
     call    [ExitProcess]

  DisplayErrorMessageBye:
     cmp     [isMessageDisplaying],01
     jne     .go
     push    0
     call    [ExitProcess]
     .go:
     mov     [isMessageDisplaying],01
     push    MB_OK or MB_ICONHAND
     push    ERROR_TITLE
     push    FATAL_ERROR_BYE
     push    [MainWindow]
     call    [MessageBoxA]
     mov     [isMessageDisplaying],00
     push    0
     call    [ExitProcess]

  DisplayHotkeyErrorMessageA:
     cmp     [isMessageDisplaying],01
     jne     .go
     push    0
     call    [ExitProcess]
     .go:
     mov     [isMessageDisplaying],01
     push    MB_OK or MB_ICONHAND
     push    ERROR_TITLE
     push    HOTKEY_ENABLE_ERROR
     push    [MainWindow]
     call    [MessageBoxA]
     mov     [isMessageDisplaying],00
     push    0
     call    [ExitProcess]

  DisplayHotkeyErrorMessageB:
     cmp     [isMessageDisplaying],01
     jne     .go
     push    0
     call    [ExitProcess]
     .go:
     mov     [isMessageDisplaying],01
     push    MB_OK or MB_ICONHAND
     push    ERROR_TITLE
     push    HOTKEY_DNABLE_ERROR
     push    [MainWindow]
     call    [MessageBoxA]
     mov     [isMessageDisplaying],00
     push    0
     call    [ExitProcess]

  ; ======================================================= M y     F u n c t i o n s     E n d =======================================================

section '.data' data readable writeable

  FATAL_ERROR	      db 'FATAL ERROR!',0
  ERROR_RUNGAME_FIRST db 'Please, run the game first!',0
  ERROR_TITLE	      db 'ERROR',0
  HOTKEY_ENABLE_ERROR db 'I couldn''t activate the hotkeys.',0
  HOTKEY_DNABLE_ERROR db 'I couldn''t deactivate the hotkeys.',0
  FATAL_ERROR_BYE     db 'FATAL ERROR! I cannot continue. Bye!',0
  STATIC	      db 'STATIC',0
  EDIT		      db 'EDIT',0
  GAME_NOTFOUND_TITLE db 'Run the Game!',0
  GAME_FOUND_TITLE    db 'Game Detected!',0

  GameWindowClass     db 'MainWindow',0
  GameWindowTitle     db 'Peggle Nights Deluxe 1.0',0
  MainTimer	      dd 576
  HOTKEY_001	      dd 801
  HOTKEY_002	      dd 802
  HOTKEY_003	      dd 803
  HOTKEY_004	      dd 804
  HOTKEY_005	      dd 805
  HOTKEY_006	      dd 806
  HOTKEY_007	      dd 807
  HOTKEY_008	      dd 808
  HOTKEY_009	      dd 809
  HOTKEY_010	      dd 810

  SCROLL_HOTKEY       dd 850
  FROM_RESOURCE       dd $40004
  PLAY_FROM_MEMORY    dd $04
  PLAY_ASYNC	      dd $01

  PreviousCursorPos   POINT
  CursorPosition      POINT
  ScreenWidth	      dd ?
  ScreenHeight	      dd ?
  MainWindow	      dd ?
  LOAD_BMP	      dd ?
  isMessageDisplaying db $00
  GameWindow	      dd ?
  myProcess	      dd ?
  CloseTrainer	      db $00
  HotkeysEnabled      db $00
  PS		      PAINTSTRUCT
  HDC		      dd ?
  HDCMEM	      dd ?
  BMT		      dd ?
  BM		      BITMAP

  ; HAPPYALLOC AND GENERAL CHEAT RELATED
  THRID 	      dd ?
  PROCID	      dd ?
  PROCHANDLE	      dd ?
  MYWRITE	      dd ?
  MYREAD	      dd ?
  CHECK 	      db ?
  GAMEWINDOW	      dd ?
  OLDPROTECTION       dd ?
  ALLOCATEDMEM	      dd ?
  HAPPYWINDOW	      dd ?
  HAPPYMEM	      dd ?
  HappyMemSucceed     db $00
  E9		      db $E9
  E8		      db $E8
  C3		      db $C3
  SINGLE_NOP	      db $90
  DOUBLE_NOP	      dw $9090
  TRIPLE_NOP	      db $90, $90, $90
  QUAD_NOP	      dd $90909090
  HEXA_NOP	      db $90, $90, $90, $90, $90, $90
  DOUBLE_QUAD_NOP     dq $9090909090909090
  BYTES_TO_ALLOC      dd ?
  ADDRESS_VALUE       dd ?
  FINAL_ADDRESS       dd ?
  CURRENT_VALUE       dd ?
  CURRENT_ROC	      dd $00CC0020

  HAPPYMODULE:
  .dwSize	      dd ?
  .th32ModuleID       dd ?
  .th32ProcessID      dd ?
  .GlblcntUsage       dd ?
  .ProccntUsage       dd ?
  .modBaseAddr	      dd ?
  .modBaseSize	      dd ?
  .hModule	      dd ?
  .szModule	      TCHAR 256 dup ?
  .szExePath	      TCHAR MAX_PATH dup ?
  HAPPYMODULE_END:    db 10 dup($90)

  DLL_TO_ALLOC	      db $E9, $00, $00, $00, $00, $90
  LOAD_DLL_ARRAY      db $68, $00, $00, $00, $00, $FF, $15, $00, $00, $00, $00, $68, $00, $00, $00, $00, $50, $FF, $15, $00, $00, $00, $00, $FF, $D0, $FF, $15, $00, $00, $00, $00
  DLL_PATH	      db 256 dup($00)
  DLL_FUNCTION	      db 'DLL_Start',0
  RDK_DLL	      db '\rdk.dll',0

  nBufferLength       dd 256
  lpBuffer	      db 256 dup ?

  HAPPYDLL	      db 'BASS.DLL',0
  PROCSNAPSHOT	      dd ?
  BASEADDRESS	      dd ?
  THREAD_ID	      dd ?
  THREAD_HANDLE       dd ?

section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
	  winmm,'WINMM.DLL',\
	  ntdll,'NTDLL.DLL',\
	  gdi,'GDI32.DLL'

  include 'D:\FASM\INCLUDE\API\KERNEL32.INC'
  include 'D:\FASM\INCLUDE\API\USER32.INC'
  include 'D:\FASM\INCLUDE\API\GDI32.INC'

  import winmm,\
	 PlaySoundA,'PlaySoundA'

  import ntdll,\
	 NtWriteVirtualMemory,'NtWriteVirtualMemory',\
	 NtReadVirtualMemory,'NtReadVirtualMemory'

section '.res' resource data readable

  directory RT_ICON, icons,\
	    RT_GROUP_ICON, group_icons


  resource icons,\
	   1,LANG_NEUTRAL,icon_data

  resource group_icons,\
	   100,LANG_NEUTRAL,main_icon

  icon main_icon, icon_data,'icon.ico'